import 'package:result_monad/result_monad.dart';

import '../../models/connection.dart';
import '../../models/exec_error.dart';
import '../../models/group_data.dart';

abstract class IGroupsRepo {
  void addAllGroups(List<GroupData> groups);

  void addConnectionToGroup(GroupData group, Connection connection);

  void clearMyGroups();

  void upsertGroup(GroupData group);

  void deleteGroup(GroupData group);

  List<GroupData> getMyGroups();

  Result<List<Connection>, ExecError> getGroupMembers(GroupData group);

  Result<List<GroupData>, ExecError> getGroupsForUser(String id);

  bool updateConnectionGroupData(String id, List<GroupData> currentGroups);
}
